]> git.ipfire.org Git - people/ms/network.git/blame - src/functions/functions.util
util: Fix cmd function and never leak anything into the environment
[people/ms/network.git] / src / functions / functions.util
CommitLineData
1848564d
MT
1#!/bin/bash
2###############################################################################
3# #
4# IPFire.org - A linux based firewall #
5# Copyright (C) 2010 Michael Tremer & Christian Schmidt #
6# #
7# This program is free software: you can redistribute it and/or modify #
8# it under the terms of the GNU General Public License as published by #
9# the Free Software Foundation, either version 3 of the License, or #
10# (at your option) any later version. #
11# #
12# This program is distributed in the hope that it will be useful, #
13# but WITHOUT ANY WARRANTY; without even the implied warranty of #
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15# GNU General Public License for more details. #
16# #
17# You should have received a copy of the GNU General Public License #
18# along with this program. If not, see <http://www.gnu.org/licenses/>. #
19# #
20###############################################################################
21
97cb552e 22# A simple print statement
1c6a4e30 23print() {
acc9efd5
MT
24 local fmt=${1}; shift
25
40e3553f 26 printf -- "${fmt}\n" "$@"
97cb552e
MT
27}
28
67baa452
MT
29print_indent() {
30 local i=${1}
31 shift
32
33 while (( i-- )); do
34 printf "\t"
35 done
36
37 print "%s" "$@"
38}
39
cb965348
MT
40# The args() function takes a number of arguments like
41# var1="abc d" var2="abc" var3="abcd e"
42# and splits them into several arguments, devided by newline
1c6a4e30 43args() {
cb965348
MT
44 echo "$@" | xargs printf "%s\n"
45}
46
1c6a4e30 47unquote() {
04854c77
MT
48 local var="$@"
49
50 if [ "${var:0:1}" = "\"" ]; then
51 var=${var:1}
52 fi
53
54 local last=$(( ${#var} - 1 ))
55 if [ ${last} -ge 0 ] && [ "${var:${last}:1}" = "\"" ]; then
56 var=${var:0:${last}}
57 fi
58
59 print "${var}"
60}
61
1c6a4e30 62quote() {
04854c77
MT
63 print "\"%s\"" "$@"
64}
65
1c6a4e30 66strip() {
fe52c5e0
MT
67 local value="$@"
68
69 # remove leading whitespace characters
70 value="${value#"${value%%[![:space:]]*}"}"
71
72 # remove trailing whitespace characters
73 value="${value%"${value##*[![:space:]]}"}"
74
75 print "${value}"
76}
77
1848564d 78# Print a pretty error message
1c6a4e30 79error() {
fcbf6823 80 echo -e " ${CLR_RED_B}ERROR${CLR_RESET} : $@" >&2
1848564d
MT
81}
82
1c6a4e30 83error_log() {
1b7a1578
MT
84 log ERROR "$@"
85}
86
1848564d 87# Print a pretty warn message
1c6a4e30 88warning() {
fcbf6823 89 echo -e " ${CLR_YELLOW_B}WARNING${CLR_RESET}: $@" >&2
1848564d
MT
90}
91
1c6a4e30 92warning_log() {
1b7a1578
MT
93 log WARNING "$@"
94}
95
1848564d 96# Speedup function to avoid a call of the basename binary
1c6a4e30 97basename() {
1848564d
MT
98 echo "${1##*/}"
99}
100
1c6a4e30 101format() {
e5651e17
MT
102 local key=${1}
103 assert isset key
104
105 local format=${2}
106 assert isset format
107
108 shift 2
109
110 printf -v "${key}" "${format}" "$@"
111}
112
d13929d4
MT
113format_time() {
114 local s=${1}
115 local ret m
116
117 local units="s m h"
118
119 local unit
120 for unit in ${units}; do
121 m=$(( ${s} % 60 ))
122 s=$(( ${s} / 60 ))
123
124 if [ ${m} -gt 0 ]; then
125 ret="${m}${unit} ${ret}"
126 fi
127 done
128
129 # Remove whitespace
130 echo ${ret}
131}
132
b383499d
MT
133parse_time() {
134 local ret=0
135
136 local arg
137 for arg in $@; do
138 local unit
139
140 case "${arg}" in
141 *h|*m|*s)
142 # Store unit
143 unit="${arg: -1}"
144
145 # Remove unit
146 arg="${arg:0:-1}"
147 ;;
148 esac
149
150 if ! isinteger arg; then
151 return ${EXIT_ERROR}
152 fi
153
154 # Convert hours and minutes into seconds
155 case "${unit}" in
156 h)
157 arg=$(( ${arg} * 3600 ))
158 ;;
159 m)
160 arg=$(( ${arg} * 60 ))
161 ;;
162 esac
163
164 # Add up everything
165 ret=$(( ${ret} + ${arg} ))
166 done
167
168 print "${ret}"
169}
170
1c6a4e30 171assign() {
b79ad79b
MT
172 local key=${1}
173 assert isset key
174 shift
175
e5651e17 176 format "${key}" "%s" "$@"
b79ad79b
MT
177}
178
1c6a4e30 179fread() {
b79ad79b
MT
180 local file=${1}
181 assert isset file
182
183 [ -r "${file}" ] || return ${EXIT_ERROR}
184
185 print "$(<${file})"
186}
187
1c6a4e30 188fwrite() {
b79ad79b
MT
189 local file=${1}
190 assert isset file
191 shift
192
644d3bb8
MT
193 if ! print "%s" "$@" > ${file} 2>/dev/null; then
194 error "Could not write to file: ${file}"
195 return ${EXIT_ERROR}
196 fi
197
198 return ${EXIT_OK}
199}
200
201fappend() {
202 local file=${1}
203 assert isset file
204 shift
205
e1947a76 206 if [ -e "${file}" ] && [ ! -w "${file}" ]; then
8d4e0d52
MT
207 log ERROR "${file}: No such file"
208 return ${EXIT_ERROR}
209 fi
210
211 print "%s" "$@" >> ${file} 2>/dev/null
b79ad79b
MT
212}
213
fa33d830
MT
214file_delete() {
215 local file=${1}
216
217 unlink "${file}" 2>/dev/null
218}
219
e1947a76
MT
220file_exists() {
221 local file=${1}
222
223 [ -e "${file}" ] && return ${EXIT_TRUE} || return ${EXIT_FALSE}
224}
225
226file_is_newer_than() {
227 local file1="${1}"
228 local file2="${2}"
229
230 local age1=$(file_get_age "${file1}")
231 local age2=$(file_get_age "${file2}")
232
233 if [ ${age1} -gt ${age2} ]; then
234 return ${EXIT_TRUE}
235 else
236 return ${EXIT_FALSE}
237 fi
238}
239
240file_get_age() {
241 local file="${1}"
242
243 if [ -e "${file}" ]; then
244 stat --format="%Y" "${file}"
245 return $?
246 fi
247
248 return ${EXIT_ERROR}
249}
250
c041b631
MT
251make_parent_dir() {
252 local path="${1}"
253
254 local dirname="$(dirname "${path}")"
255 mkdir -p "${dirname}"
256}
257
1c6a4e30 258enabled() {
1848564d
MT
259 local param=${1}
260
e726ef8d 261 list_match "${!param}" yes on true 1
1848564d
MT
262}
263
1c6a4e30 264mac_generate() {
fb1416c6
MT
265 local b="$(random 12)"
266
267 # Remove multicast bit
268 # and set address is software assigned
269 local first_byte=$(( 0x${b:0:2} & 0xfe ))
270 first_byte=$(( ${first_byte} | 0x02 ))
1848564d
MT
271
272 local output
fb1416c6 273 printf -v output "%02x" "${first_byte}"
790b7ec9 274
fb1416c6 275 output="${output}:${b:2:2}:${b:4:2}:${b:6:2}:${b:8:2}:${b:10:2}"
1848564d
MT
276
277 # Check if output is valid
fb1416c6 278 assert mac_is_valid "${output}"
1848564d 279
790b7ec9 280 echo "${output}"
1848564d
MT
281}
282
1c6a4e30 283mac_format() {
18b43372 284 local mac=${1}
48bc31eb 285 assert isset mac
18b43372 286
48bc31eb
MT
287 # Remove all colons and make the rest lowercase.
288 mac=${mac//:/}
289 mac=${mac,,}
18b43372 290
48bc31eb 291 local output
18b43372
MT
292 if [ "${#mac}" = "12" ]; then
293 # Add colons (:) to mac address
294 output=${mac:0:2}
295 local i
296 for i in 2 4 6 8 10; do
297 output="${output}:${mac:${i}:2}"
298 done
48bc31eb
MT
299 else
300 output=${mac}
18b43372
MT
301 fi
302
303 assert mac_is_valid ${output}
304
48bc31eb 305 print "${output}"
18b43372
MT
306}
307
1c6a4e30 308mac_is_valid() {
1848564d
MT
309 local mac=${1}
310
311 [[ ${mac} =~ ^([0-9a-f]{2}\:){5}[0-9a-f]{2}$ ]]
312}
313
1c6a4e30 314uuid() {
de543653 315 echo $(</proc/sys/kernel/random/uuid)
1848564d
MT
316}
317
a24cff8f
JS
318abs() {
319 local val=${1}
320
321 if [ ${val} -lt 0 ]; then
322 (( val *= -1 ))
323 fi
324
325 echo ${val}
326}
327
fb1416c6
MT
328rand() {
329 local uuid="$(uuid)"
330 echo "${uuid//-/}"
331}
332
333random() {
334 local length="${1:-8}"
335
336 local random
337 while [ ${#random} -lt ${length} ]; do
338 random="${random}$(rand)"
339 done
340
341 echo "${random:0:${length}}"
342}
343
1c6a4e30 344isset() {
1848564d
MT
345 local var=${1}
346
347 [ -n "${!var}" ]
348}
349
1c6a4e30 350isoneof() {
1848564d
MT
351 local var=${!1}
352 shift
353
e726ef8d 354 list_match "${var}" "$@"
1848564d
MT
355}
356
1c6a4e30 357isbool() {
1848564d
MT
358 local var=${1}
359
ec6afbdd 360 isoneof ${var} 0 1 no yes on off true false
1848564d
MT
361}
362
1c6a4e30 363isinteger() {
1848564d
MT
364 local var=${!1}
365
366 [[ ${var} =~ ^[0-9]+$ ]]
367}
368
1c6a4e30 369ismac() {
1848564d
MT
370 local mac=${!1}
371
372 mac_is_valid ${mac}
373}
374
1c6a4e30 375isipaddress() {
fef4edaf
MT
376 local addr=${!1}
377
378 ip_is_valid ${addr}
379}
380
48a64768
JS
381mtu_is_valid() {
382 local proto=${1}
383 local mtu=${2}
384
385 case ${proto} in
386 ipv4)
387 [ ${mtu} -ge 576 ] && [ ${mtu} -le 9000 ]
388 ;;
389 ipv6)
390 [ ${mtu} -ge 1280 ] && [ ${mtu} -le 9000 ]
391 ;;
392 *)
393 error "${proto} is not a valid proto"
394 return ${EXIT_ERROR}
395 ;;
396 esac
397}
398
1c6a4e30 399backtrace() {
711ffac1
MT
400 local start=1
401
402 echo # Empty line
403 error_log "Backtrace (most recent call in first line):"
404
04608623 405 local i source
711ffac1
MT
406 for i in $(seq ${start} ${#BASH_SOURCE[*]}); do
407 [ -z "${FUNCNAME[${i}]}" ] && continue
6396ccab
MT
408
409 # Print called binary with arguments.
410 if [ "${FUNCNAME[${i}]}" == "main" ]; then
411 local args="$(list_reverse ${BASH_ARGV[*]})"
412 printf -v source "%20s" "$0"
413 error_log " ${source} ${args}"
414 continue
415 fi
711ffac1 416
04608623
MT
417 source=${BASH_SOURCE[$(( ${i} + 1 ))]}
418 error_log " $(printf "%20s" "'${FUNCNAME[${i}]}'") called from ${source:-<shell>}:${BASH_LINENO[${i}]}"
711ffac1
MT
419 done
420}
421
1c6a4e30 422assert() {
1848564d
MT
423 local assertion="$@"
424
425 if ! ${assertion}; then
4c670d7c 426 error_log "Assertion '${assertion}' failed."
711ffac1 427 backtrace
cfbe0802 428 exit ${EXIT_ERROR_ASSERT}
1848564d
MT
429 fi
430
431 return ${EXIT_OK}
432}
cad8bd85 433
b0b2f995
MT
434# This function checks, if the given argument is an assert error
435# exit code. If this is the case, the script will halt immediately.
1c6a4e30 436assert_check_retval() {
b0b2f995
MT
437 local ret=${1}
438
439 if [ ${ret} -eq ${EXIT_ERROR_ASSERT} ]; then
440 exit ${EXIT_ERROR_ASSERT}
441 fi
442
443 return ${ret}
444}
445
2bb20bbd
SS
446# This function executes the given command and inverses the return code
447not() {
448 local command="$@"
449
450 ${command} && return ${EXIT_FALSE} || return ${EXIT_TRUE}
451}
452
1c6a4e30 453exec_cmd() {
711ffac1
MT
454 local cmd=$@
455
456 log DEBUG "Running command: ${cmd}"
457
b816e04b 458 DEBUG=${DEBUG} \
8c63fa13
MT
459 LOG_DISABLE_STDOUT="${LOG_DISABLE_STDOUT}" \
460 LOG_FACILITY="${LOG_FACILITY}" \
b816e04b 461 ${SHELL} ${cmd}
711ffac1
MT
462 local ret=$?
463
464 #log DEBUG "Returned with code '${ret}'"
465
466 if [ ${ret} -eq ${EXIT_ERROR_ASSERT} ]; then
467 error_log "Stopping parent process due to assertion error in child process: ${cmd}"
468 exit ${EXIT_ERROR_ASSERT}
469 fi
470
471 return ${ret}
472}
473
1c6a4e30 474cmd() {
b816e04b
MT
475 local cmd=$@
476
477 log DEBUG "Running command: ${cmd}"
478
4b75fc83
MT
479 env -i -- \
480 HOME="${HOME}" \
481 PATH="${PATH}" \
482 TERM="${TERM}" \
483 ${cmd}
484 local ret=$?
b816e04b 485
4b75fc83
MT
486 case "${ret}" in
487 ${EXIT_OK})
488 return ${EXIT_OK}
489 ;;
490 *)
491 log DEBUG "Returned with code '${ret}'"
492 return ${ret}
493 ;;
494 esac
b816e04b
MT
495}
496
1c6a4e30 497cmd_quiet() {
98146c00 498 cmd $@ &>/dev/null
3efecbb3
MT
499}
500
1c6a4e30 501cmd_exec() {
f80ce052
MT
502 local cmd=$@
503
504 log DEBUG "Exec'ing command: ${cmd}"
505
506 exec ${cmd}
507
508 log ERROR "Could not exec-ute: ${cmd}"
509 exit ${EXIT_ERROR}
510}
511
1c6a4e30 512cmd_not_implemented() {
2181765d
MT
513 assert false "not implemented"
514}
515
de3cecef
MT
516# Runs a command in a clean environment so that no confidential information
517# is leaked to any untrusted commands.
518cmd_clean_environment() {
519 local cmd=$@
520
521 log DEBUG "Running command in a clean environment: ${cmd}"
522 env -i -- ${cmd}
523 local ret=${?}
524
525 log DEBUG "Returned with code '${ret}'"
526 return ${ret}
527}
528
f5ee091e
MT
529# Executes the given command in background
530cmd_background() {
531 cmd_quiet $@ &
532}
533
534# Prints the PID of the process that was started last
535cmd_background_get_pid() {
536 print "${!}"
537}
538
539cmd_background_result() {
540 local pids=$@
541
542 wait ${pids}
543}
544
b8026986 545# Increase security of the read command
1c6a4e30 546read() {
b8026986
MT
547 builtin read -r $@
548}
549
1c6a4e30 550seq() {
3efecbb3
MT
551 if [ $# -eq 2 ]; then
552 eval echo {${1}..${2}}
553 elif [ $# -eq 3 ]; then
554 eval echo {${1}..${3}..${2}}
555 fi
556}
557
de72bd91
MT
558range() {
559 eval echo {0..$(( ${1} - 1 ))}
560}
561
562count() {
563 local i=0
564
565 while read; do
566 ((i++))
567 done
568
569 echo ${i}
570}
571
1c6a4e30 572which() {
76e6cd51
MT
573 type -P $@
574}
575
fe52c5e0 576# Prints the number of seconds since epoch.
1c6a4e30 577timestamp() {
fe52c5e0
MT
578 date -u "+%s"
579}
580
1c6a4e30 581beautify_time() {
d82cf370
MT
582 local value=${1}
583
584 local unit
585 local limit
586 for unit in s m h d w; do
587 case "${unit}" in
588 s|m|h)
589 limit=60
590 ;;
591 d)
592 limit=24
593 ;;
594 w)
595 limit=7
596 ;;
597 esac
598
599 [ ${value} -lt ${limit} ] && break
600
601 value=$(( ${value} / ${limit} ))
602 done
603
604 echo "${value}${unit}"
605}
711ffac1 606
1c6a4e30 607beautify_bytes() {
711ffac1
MT
608 local value=${1}
609
610 local unit
611 local limit=1024
612 for unit in B k M G T; do
613 [ ${value} -lt ${limit} ] && break
614 value=$(( ${value} / ${limit} ))
615 done
616
617 echo "${value}${unit}"
618}
943e3f7e 619
1c6a4e30 620module_load() {
943e3f7e
MT
621 local module=${1}
622
623 if ! grep -q "^${module}" /proc/modules; then
624 log DEBUG "Loading module '${module}'."
625 modprobe ${module}
626 fi
627}
6b3f9c85 628
1c6a4e30 629binary_exists() {
6b3f9c85
MT
630 local binary=${1}
631
632 if [ -n "$(type -p ${binary})" ]; then
633 return ${EXIT_OK}
634 fi
635
636 return ${EXIT_ERROR}
637}
d76f5107 638
1c6a4e30 639function_exists() {
1e6f187e
MT
640 local function="${1}"
641
642 if [ "$(type -t "${function}")" = "function" ]; then
643 return ${EXIT_TRUE}
644 fi
645
646 return ${EXIT_FALSE}
647}
648
1c6a4e30 649process_kill() {
d76f5107
MT
650 local process=${1}
651
652 if ! isinteger process; then
653 process=$(pidof ${process})
654 fi
655
656 local pid
657 local sig
658 for pid in ${process}; do
659 for sig in 15 9; do
660 [ -d "/proc/${pid}" ] || break
661
662 kill -${sig} ${pid}
663 sleep 1
664 done
665 done
666}
feb76eaf 667
1c6a4e30 668dec() {
feb76eaf
MT
669 local hex=${1}
670
671 if [ "${hex:0:2}" != "0x" ]; then
672 hex="0x${hex}"
673 fi
674
675 printf "%d\n" "${hex}"
676}
3a7fef62 677
1c6a4e30 678chr() {
5cf0edf9
MT
679 local char="${1}"
680
681 [ ${char} -lt 256 ] || return ${EXIT_ERROR}
682
683 printf "\\$(( ${char} / 64 * 100 + ${char} % 64 / 8 * 10 + ${char} % 8 ))\n"
684}
685
1c6a4e30 686ord() {
5cf0edf9
MT
687 LC_CTYPE="C" printf "%d\n" "'${1}"
688}
689
1c6a4e30 690hex() {
5cf0edf9
MT
691 printf "%X\n" "${1}"
692}
693
1c6a4e30 694network_is_running() {
3a7fef62
MT
695 # Check, if the network service is running.
696 service_is_active network
697}
f80ce052 698
1c6a4e30 699contains_spaces() {
f80ce052
MT
700 local var="$@"
701
702 # Eliminate spaces.
703 local var2=${var// /}
704
705 if [ ${#var} -ne ${#var2} ]; then
706 return ${EXIT_TRUE}
707 fi
708
709 return ${EXIT_FALSE}
0d645497
MT
710}
711
712string_match() {
713 local match=${1}
714 local string=${2}
715
716 [[ ${string} =~ ${match} ]] && return ${EXIT_TRUE} || return ${EXIT_FALSE}
f80ce052 717}
5cf0edf9 718
1c6a4e30 719string_split() {
5cf0edf9
MT
720 local string="$@"
721
722 local pos=0
723 while [ ${pos} -lt ${#string} ]; do
724 print "${string:${pos}:1}"
725 pos=$(( ${pos} + 1 ))
726 done
727
728 return ${EXIT_OK}
729}
730
1c6a4e30 731string_reverse() {
5cf0edf9
MT
732 local string="$@"
733
734 local output
735 local pos=0
736 while [ ${pos} -lt ${#string} ]; do
737 output="${string:${pos}:1}${output}"
738 pos=$(( ${pos} + 1 ))
739 done
740
741 print "${output}"
742 return ${EXIT_OK}
743}
744
1c6a4e30 745dec2bin() {
5cf0edf9
MT
746 local number="${1}"
747
748 local output
749
750 local i div
751 for i in 7 6 5 4 3 2 1; do
752 div=$(( 2 ** ${i} ))
753
754 if [ $(( ${number} / ${div} )) -eq 1 ]; then
755 output="${output}1"
756 else
757 output="${output}0"
758 fi
759 number="$(( ${number} % ${div} ))"
760 done
761
762 if [ $(( ${number} % 2 )) -eq 1 ]; then
763 output="${output}1"
764 else
765 output="${output}0"
766 fi
767
768 print "${output}"
769}
770
1c6a4e30 771bin2dec() {
5cf0edf9
MT
772 local string="${1}"
773 local number=0
774
775 local pos=0 char
776 while [ ${pos} -lt ${#string} ]; do
777 char="${string:${pos}:1}"
778 pos=$(( ${pos} + 1 ))
779
780 number=$(( ${number} << 1 ))
781
782 case "${char}" in
783 0) ;;
784 1)
785 number=$(( ${number} + 1 ))
786 ;;
787 *)
788 assert false "Invalid character: ${char}"
789 ;;
790 esac
791 done
792
793 print "${number}"
794 return ${EXIT_OK}
795}
796
1c6a4e30 797char2bin() {
5cf0edf9
MT
798 local dec="$(ord "${1}")"
799
800 dec2bin "${dec}"
801}
802
1c6a4e30 803bin2char() {
5cf0edf9
MT
804 local dec="$(bin2dec "$@")"
805
806 chr "${dec}"
807}
808
1c6a4e30 809bin2hex() {
5cf0edf9
MT
810 local dec="$(bin2dec "$@")"
811
812 dec2hex "${dec}"
813}
814
1c6a4e30 815hex2bin() {
5cf0edf9
MT
816 local dec="$(hex2dec "$@")"
817
818 dec2bin "${dec}"
819}
820
1c6a4e30 821hex2dec() {
5cf0edf9
MT
822 local hex="${1}"
823
824 # Prepend 0x if necessary.
825 [ "${hex:0:2}" = "0x" ] || hex="0x${hex}"
826
827 printf "%d\n" "${hex}"
828}
829
1c6a4e30 830dec2hex() {
5cf0edf9
MT
831 printf "%02x\n" "${1}"
832}
a95d16fc 833
10b53c87 834# This function just copy config files
a95d16fc 835copy() {
a95d16fc
JS
836 assert [ $# -eq 2 ]
837
838 local src=${1}
839 local dst=${2}
840
287c2e60
MT
841 # Check if we can read from the source
842 if [ ! -r "${src}" ]; then
843 log ERROR "Cannot read ${src}"
844 return ${EXIT_ERROR}
845 fi
846
a95d16fc 847 # Check if ${dst} is a directory
1fade616 848 if [ -d "${dst}" ]; then
9c802e1d 849 log ERROR "${dst} is a directory"
a95d16fc
JS
850 return ${EXIT_ERROR}
851 fi
852
853 if ! fread "${src}" > "${dst}"; then
854 log ERROR "Could not copy data from ${src} to ${dst}"
855 return ${EXIT_ERROR}
856 fi
857}